Debian Bug report logs - #584102
OpenVZ vzctl enter dying with: Unable to open pty: No such file or directory; problem with tcgetattr() and startpar

version graph

Package: sysvinit-utils; Maintainer for sysvinit-utils is Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>; Source for sysvinit-utils is src:sysvinit.

Reported by: Bartosz Pierzchala <bartosz.pierzchala@gmail.com>

Date: Tue, 1 Jun 2010 09:39:02 UTC

Severity: serious

Tags: sid, squeeze

Merged with 583562

Found in versions sysvinit/2.88dsf-5, sysvinit/2.86.ds1-61

Fixed in version sysvinit/2.88dsf-8

Done: Petter Reinholdtsen <pere@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#584102; Package sysvinit. (Tue, 01 Jun 2010 09:39:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bartosz Pierzchala <bartosz.pierzchala@gmail.com>:
New Bug report received and forwarded. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Tue, 01 Jun 2010 09:39:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Bartosz Pierzchala <bartosz.pierzchala@gmail.com>
To: submit@bugs.debian.org
Subject: OpenVZ vzctl enter dying with: Unable to open pty: No such file or directory; problem with tcgetattr() and startpar
Date: Tue, 1 Jun 2010 11:38:18 +0200
[Message part 1 (text/plain, inline)]
Package: sysvinit
Version: 2.88dsf-5

After debootstraping testing/squeeze there's a problem when trying to
start it under OpenVZ. init starts but the rc scripts fail to properly
setup environment (run scripts from runlevel S and runlevel 2).
OpenVZ's vzctl enter VEID dies with the following error message:

# vzctl enter 1050
enter into VE 1050 failed
Unable to open pty: No such file or directory

(the above if caused by /dev/pts not being mounted)

I've narrowed the problem to startpar program which is used by init
scripts to run scripts for given runlevel in parallel. It seems that
startpar dies giving an error :

17    rt_sigaction(SIGWINCH, {0x401f40, [],
SA_RESTORER|SA_RESTART|SA_NODEFER, 0x7fcad974cf80}, NULL, 8) = 0
17    ioctl(0, SNDCTL_TMR_TIMEBASE or TCGETS, 0x7fffffffc230) = -1
ENOTTY (Inappropriate ioctl for device)
17    dup(2)                            = 3
17    fcntl(3, F_GETFL)                 = 0x8002 (flags O_RDWR|O_LARGEFILE)
17    fstat(3, {st_mode=S_IFCHR|0666, st_rdev=makedev(1, 3), ...}) = 0
17    ioctl(3, SNDCTL_TMR_TIMEBASE or TCGETS, 0x7fffffffbfe0) = -1
ENOTTY (Inappropriate ioctl for device)
17    mmap(NULL, 4096, PROT_READ|PROT_WRITE,
MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x7fcad9c87000
17    lseek(3, 0, SEEK_CUR)             = 0
17    write(3, "tcgetattr: Inappropriate ioctl for device\n", 42) = 42
17    close(3)                          = 0
17    munmap(0x7fcad9c87000, 4096)      = 0
17    exit_group(1)                     = ?



I'm attaching full strace output of startpar.

I've browsed Debian's sysvinit source and found out this call to
tcgetattr():

///
 if (tcgetattr(0, &tio))
   {
     perror("tcgetattr");
     exit(1);
   }
///

tio variable is later used to disable basic terminal output translation:
///
      tio.c_oflag &= ~OPOST;
      if (tcsetattr(1, TCSANOW, &tio))
        perror("tcsetattr");
///

When I comment this code and rebuild the package then the virtual
environment boots
successfully. I suppose that OpenVZ's "stdin"/"stdout" for init
program isn't a regular terminal
and that's the cause of tcgetattr() failing.

Should it be a fatal error if a call to tcgetattr() fails? Maybe we
could just detect the case when tcgetattr() returns 0 and if such
thing occurs - omit using tcsetattr()?



There's also one note that adding:
CONCURRENCY=none
to /etc/default/rcS
makes the system boot properly.



Host node runs Lenny and it works well. Below is the information about
the container:

-- System Information:
Debian Release: squeeze/sid
 APT prefers testing
 APT policy: (500, 'testing')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.26-2-openvz-amd64
Locale: LANG=pl_PL, LC_CTYPE=pl_PL (charmap=ISO-8859-2)
Shell: /bin/sh linked to /bin/dash

Versions of packages sysvinit depends on:
ii  initscripts                   2.88dsf-5  scripts for initializing and shutt
ii  libc6                         2.10.2-9   Embedded GNU C Library: Shared lib
ii  libselinux1                   2.0.94-1   SELinux runtime shared libraries
ii  libsepol1                     2.0.40-2   SELinux library for manipulating b
ii  sysv-rc                       2.88dsf-5  System-V-like runlevel change mech
ii  sysvinit-utils                2.88dsf-5  System-V-like utilities

sysvinit recommends no packages.

sysvinit suggests no packages.

-- no debconf information
[strace.txt (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#584102; Package sysvinit. (Wed, 02 Jun 2010 13:24:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petter Reinholdtsen <pere@hungry.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Wed, 02 Jun 2010 13:24:10 GMT) Full text and rfc822 format available.

Message #10 received at 584102@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: Bartosz Pierzchala <bartosz.pierzchala@gmail.com>, 584102@bugs.debian.org
Subject: Re: Bug#584102: OpenVZ vzctl enter dying with: Unable to open pty: No such file or directory; problem with tcgetattr() and startpar
Date: Wed, 2 Jun 2010 15:21:55 +0200
[Bartosz Pierzchala]
> There's also one note that adding:
> CONCURRENCY=none
> to /etc/default/rcS
> makes the system boot properly.

This indicate that the problem is with startpar, and not with sysvinit
as such.  Perhaps it should be changed to run sequencially if the tty
is broken?  Patches welcome.

Why do OpenVZ not provide a working tty to sysvinit/startpar?

I notice <URL: http://savannah.nongnu.org/bugs/?30034 > upstream is
about a similar issue.

Happy hacking,
-- 
Petter Reinholdtsen




Bug reassigned from package 'sysvinit' to 'sysvinit-utils'. Request was from Petter Reinholdtsen <pere@hungry.com> to control@bugs.debian.org. (Fri, 04 Jun 2010 00:36:05 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions sysvinit/2.88dsf-5. Request was from Petter Reinholdtsen <pere@hungry.com> to control@bugs.debian.org. (Fri, 04 Jun 2010 00:36:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#584102; Package sysvinit-utils. (Fri, 04 Jun 2010 01:15:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petter Reinholdtsen <pere@hungry.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 04 Jun 2010 01:15:02 GMT) Full text and rfc822 format available.

Message #19 received at 584102@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: 584102@bugs.debian.org, Bartosz Pierzchala <bartosz.pierzchala@gmail.com>
Subject: Re: Bug#584102: OpenVZ vzctl enter dying with: Unable to open pty: No such file or directory; problem with tcgetattr() and startpar
Date: Fri, 4 Jun 2010 03:10:28 +0200
[Petter Reinholdtsen]
> Why do OpenVZ not provide a working tty to sysvinit/startpar?

I very much welcome someone with OpenVZ knowledge to answer this one,
to know why startpar fail with OpenVZ.

I had a look at the startpar source, I suspect this code in startpar.c
is the failing one:

  if (tcgetattr(0, &tio))
    {
      perror("tcgetattr");
      exit(1);
    }

The tio struct is used by startpar to run this code:

      tio.c_oflag &= ~OPOST;
      if (tcsetattr(1, TCSANOW, &tio))
        perror("tcsetattr");

Not sure what OPOST does.  The manual page states

      OPOST  Enable implementation-defined output processing.

Guess someone need to test what happen if the tcgetattr() and
tcsetattr() calls are removed.  Can you test if parallel booting work
with the two code snippets disabled?

Happy hacking,
-- 
Petter Reinholdtsen




Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#584102; Package sysvinit-utils. (Fri, 04 Jun 2010 07:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petter Reinholdtsen <pere@hungry.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 04 Jun 2010 07:09:03 GMT) Full text and rfc822 format available.

Message #24 received at 584102@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: 584102@bugs.debian.org, Bartosz Pierzchala <bartosz.pierzchala@gmail.com>
Subject: Re: Bug#584102: OpenVZ vzctl enter dying with: Unable to open pty: No such file or directory; problem with tcgetattr() and startpar
Date: Fri, 4 Jun 2010 09:05:57 +0200
I had a closer look at the source, and suspect a patch like this might
solve it, by running all scripts sequencially if the tty is strange.

Index: startpar.c
===================================================================
--- startpar.c  (revision 1898)
+++ startpar.c  (working copy)
@@ -631,6 +631,7 @@
   char *prev_level = getenv("PREVLEVEL");
   char *run_level = getenv("RUNLEVEL");
   char *splashopt = 0;
+  int notty = 0;

   (void)signal(SIGUSR1, sighandler_preload);
   (void)signal(SIGUSR2, sighandler_nopreload);
@@ -813,8 +814,7 @@

   if (tcgetattr(0, &tio))
     {
-      perror("tcgetattr");
-      exit(1);
+      notty = 1;
     }
   if (ioctl(0, TIOCGWINSZ, &wz) == 0)
     wzok = 1;
@@ -904,6 +904,11 @@
                  }
                  p->splashadd = calcsplash(num, argc, splashopt);
                  p->num = num++;
+                  if (notty)
+                    {
+                      interactive_task = p;     /* no tty, treat as interactive */
+                      continue;
+                    }
                  if (interactive_task)
                    continue;                   /* don't start this here */
                  run(p);

Anyone able and willing to test if it solve the problem for OpenVZ?

Happy hacking,
-- 
Petter Reinholdtsen




Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#584102; Package sysvinit-utils. (Fri, 04 Jun 2010 09:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petter Reinholdtsen <pere@hungry.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 04 Jun 2010 09:21:05 GMT) Full text and rfc822 format available.

Message #29 received at 584102@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: 584102@bugs.debian.org, 583562@bugs.debian.org, Bartosz Pierzchala <bartosz.pierzchala@gmail.com>
Subject: Re: Bug#584102: OpenVZ vzctl enter dying with: Unable to open pty: No such file or directory; problem with tcgetattr() and startpar
Date: Fri, 4 Jun 2010 11:20:03 +0200
severity 584102 serious
severity 583562 serious
forcemerge 584102 583562
found 584102 2.88dsf-5
found 584102 2.86.ds1-61
thanks

I believe this issue is RC and severity serious, but not critical, as
a workaround is known (disable parallel booting).  It should
definitely be fixed before Squeeze is released, to avoid surprising
all OpenVZ admins.

The problem with parallel booting and OpenVZ probably exist in both
Lenny and testing, so I flag this bug as found in both those versions.

Can someone provide the output from 'stty -a' executed in a init.d
script booted by OpenVZ, to help us figure out why OpenVZ fail?  It
would give us some input on the state of the tty provided by OpenVZ.

Happy hacking,
-- 
Petter Reinholdtsen





Severity set to 'serious' from 'normal' Request was from Petter Reinholdtsen <pere@hungry.com> to control@bugs.debian.org. (Fri, 04 Jun 2010 09:21:09 GMT) Full text and rfc822 format available.

Forcibly Merged 583562 584102. Request was from Petter Reinholdtsen <pere@hungry.com> to control@bugs.debian.org. (Fri, 04 Jun 2010 09:21:11 GMT) Full text and rfc822 format available.

Bug Marked as found in versions sysvinit/2.88dsf-5. Request was from Petter Reinholdtsen <pere@hungry.com> to control@bugs.debian.org. (Fri, 04 Jun 2010 09:21:11 GMT) Full text and rfc822 format available.

Bug Marked as found in versions sysvinit/2.86.ds1-61. Request was from Petter Reinholdtsen <pere@hungry.com> to control@bugs.debian.org. (Fri, 04 Jun 2010 09:21:13 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#584102; Package sysvinit-utils. (Fri, 04 Jun 2010 12:36:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bartosz Pierzchala <bartosz.pierzchala@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 04 Jun 2010 12:36:03 GMT) Full text and rfc822 format available.

Message #42 received at 584102@bugs.debian.org (full text, mbox):

From: Bartosz Pierzchala <bartosz.pierzchala@gmail.com>
To: 584102@bugs.debian.org, Petter Reinholdtsen <pere@hungry.com>
Subject: Bug#584102: OpenVZ vzctl enter dying with: Unable to open pty: No such file or directory; problem with tcgetattr() and startpar
Date: Fri, 4 Jun 2010 14:32:24 +0200
stty -a doesn't output anything when it's being launched via init
scripts at boot time. It exits with exit code 1.

The system boots properly with startpar enabled when call to
tcgetattr() isn't a fatal error - as I've written before.

Peter, perhaps we could briefly describe the variable in your patch?

From OpenVZ's vzctl sources I can see that output file descriptor is a
pipe. I'll ask OpenVZ developers on their forum if that could be
changed to a pseudo terminal.

Thanks for your support.

2010/6/4 Petter Reinholdtsen <pere@hungry.com>:

> Can someone provide the output from 'stty -a' executed in a init.d
> script booted by OpenVZ, to help us figure out why OpenVZ fail?  It
> would give us some input on the state of the tty provided by OpenVZ.
>
> Happy hacking,
> --
> Petter Reinholdtsen
>
>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#584102; Package sysvinit-utils. (Fri, 04 Jun 2010 12:45:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petter Reinholdtsen <pere@hungry.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Fri, 04 Jun 2010 12:45:08 GMT) Full text and rfc822 format available.

Message #47 received at 584102@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: Bartosz Pierzchala <bartosz.pierzchala@gmail.com>, 584102@bugs.debian.org
Subject: Re: Bug#584102: OpenVZ vzctl enter dying with: Unable to open pty: No such file or directory; problem with tcgetattr() and startpar
Date: Fri, 4 Jun 2010 14:42:51 +0200
[Bartosz Pierzchala]
> stty -a doesn't output anything when it's being launched via init
> scripts at boot time. It exits with exit code 1.

Right.  So no tty available. :)

> The system boots properly with startpar enabled when call to
> tcgetattr() isn't a fatal error - as I've written before.

I tested, and output from scripts seem to be lost when tcgetattr()
wasn't working.  Anyway, if tcgetattr() fail, tcsetattr() will be
using bogus values when it try to set RAW mode on the tty, so it is
not enough to just disable tcgetattr().

To test this, a simple 'startpar /bin/ls /bin/ls' can be used.  This
work:

  /sbin/startpar /bin/ls /bin/ls

This do not work:

  cat /dev/null | /sbin/startpar /bin/ls /bin/ls

If the output from ls is missing, startpar is not working as it
should.

> Peter, perhaps we could briefly describe the variable in your patch?

I'm unable to understand your question, but suspect you ask for an
explanation of my patch.  It change startpar to run all scripts
sequencially if the tcgetattr() call fail, because the variable tio
set by tcgetattr() is only used when scripts are executed in parallel,
and thus it seemed safe to run scripts sequencially when it fail.

> From OpenVZ's vzctl sources I can see that output file descriptor is
> a pipe.

Thank you.  That explains the problem, yes.

> I'll ask OpenVZ developers on their forum if that could be changed
> to a pseudo terminal.

That would be nice, and should get a bunch of other boot scripts
working as well. :)

Anyway, if stdin is a pipe with OpenVZ, my proposed patch should work,
and I will prepare an upload with that fix in place.  Even better
would be to find a way to run the scripts in parallel also on OpenVZ,
but that will have to wait for later. :)

Happy hacking,
-- 
Petter Reinholdtsen




Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#584102; Package sysvinit-utils. (Mon, 07 Jun 2010 14:33:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Dr. Werner Fink" <werner@suse.de>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Mon, 07 Jun 2010 14:33:07 GMT) Full text and rfc822 format available.

Message #52 received at 584102@bugs.debian.org (full text, mbox):

From: "Dr. Werner Fink" <werner@suse.de>
To: Petter Reinholdtsen <pere@hungry.com>
Cc: sysvinit-devel@nongnu.org, 584102@bugs.debian.org
Subject: Re: [sysvinit-devel] startpar: Fail if fd 0 is strange tty
Date: Mon, 7 Jun 2010 16:28:16 +0200
On Fri, Jun 04, 2010 at 10:18:18AM +0200, Petter Reinholdtsen wrote:
> Hi, Werner.  Not sure where to send startpar issues, so I try here as
> I know I can reach you here. :)
> 
> I proposed a patch for <URL: http://bugs.debian.org/584102 >, basicly
> allowing startpar to continue even when tcgetattr(0, &tio) by running
> scripts sequencially.  Can you have a look at let me know if it make
> sense.  This issue is also reported as
> <URL: http://savannah.nongnu.org/bugs/?30034 >.
> 
> Btw, why do startpar need stdin to be a tty?

That is a guess but nevertheless the attributes are used
to set them also to the pty/tty pairs used for parallel
boot.  As stdout of startpar can be used for a shell
script parser (without option -M) the stdio was guessed
to be a real tty.


      Werner

-- 
  "Having a smoking section in a restaurant is like having
          a peeing section in a swimming pool." -- Edward Burr




Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#584102; Package sysvinit-utils. (Mon, 07 Jun 2010 14:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petter Reinholdtsen <pere@hungry.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Mon, 07 Jun 2010 14:51:03 GMT) Full text and rfc822 format available.

Message #57 received at 584102@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: sysvinit-devel@nongnu.org, 584102@bugs.debian.org
Subject: Re: startpar: Fail if fd 0 is strange tty
Date: Mon, 7 Jun 2010 16:49:39 +0200
[Dr. Werner Fink]
> That is a guess but nevertheless the attributes are used to set them
> also to the pty/tty pairs used for parallel boot.  As stdout of
> startpar can be used for a shell script parser (without option -M)
> the stdio was guessed to be a real tty.

Right.

Any idea how to get parallel booting working also when stdin and
stdout is a pipe, like it is with OpenVZ at the moment?

Happy hacking,
-- 
Petter Reinholdtsen




Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#584102; Package sysvinit-utils. (Mon, 07 Jun 2010 15:15:14 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Dr. Werner Fink" <werner@suse.de>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Mon, 07 Jun 2010 15:15:14 GMT) Full text and rfc822 format available.

Message #62 received at 584102@bugs.debian.org (full text, mbox):

From: "Dr. Werner Fink" <werner@suse.de>
To: Petter Reinholdtsen <pere@hungry.com>, 584102@bugs.debian.org
Cc: sysvinit-devel@nongnu.org
Subject: Re: Bug#584102: startpar: Fail if fd 0 is strange tty
Date: Mon, 7 Jun 2010 17:13:11 +0200
On Mon, Jun 07, 2010 at 04:49:39PM +0200, Petter Reinholdtsen wrote:
> [Dr. Werner Fink]
> > That is a guess but nevertheless the attributes are used to set them
> > also to the pty/tty pairs used for parallel boot.  As stdout of
> > startpar can be used for a shell script parser (without option -M)
> > the stdio was guessed to be a real tty.
> 
> Right.
> 
> Any idea how to get parallel booting working also when stdin and
> stdout is a pipe, like it is with OpenVZ at the moment?

Hmmm ... stderr maybe, something like

  FILE* io[3];
  int notty = 1;

  io[0] = stdin;
  io[1] = stdout;
  io[2] = stderr;
  io[3] = NULL;

  for (n=0; io[n]; n++) {
    int fd = isatty(fileno(io[n]));
    if (tcgetattr(fd, &tio) == 0) {
	notty = 0
	break;
    }
  }

could work.

Btw: I've lost your mail

 Alternative startpar implementation - live-net-startpar

please resend.  Beside any startpar it could be an option
to use a directory based boot scheme as insserv aloready
uses a tsort which can be mapped on `directory' based
sorting scheme.  Could work simliar like the process_path()
routine of simpleinit ;)

     Werner

-- 
  "Having a smoking section in a restaurant is like having
          a peeing section in a swimming pool." -- Edward Burr




Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#584102; Package sysvinit-utils. (Mon, 07 Jun 2010 17:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petter Reinholdtsen <pere@hungry.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Mon, 07 Jun 2010 17:51:03 GMT) Full text and rfc822 format available.

Message #67 received at 584102@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: 584102@bugs.debian.org, sysvinit-devel@nongnu.org
Subject: Re: Bug#584102: startpar: Fail if fd 0 is strange tty
Date: Mon, 7 Jun 2010 19:48:08 +0200
[Dr. Werner Fink]
> Hmmm ... stderr maybe, something like

I do not know, but suspect stderr is a pipe too.  Is a tty required to
run scripts in parallel?  Lets keep this discussion CCed to the BTS
(584102@bugs.debian.org).

> Btw: I've lost your mail

Bounced it to you.

> Beside any startpar it could be an option to use a directory based
> boot scheme as insserv aloready uses a tsort which can be mapped on
> `directory' based sorting scheme.  Could work simliar like the
> process_path() routine of simpleinit ;)

upstart is getting support for handling init.d scripts natively, so
that will be an alternative too.

Would be nice to get startpar to start rcS.d/ and rc2.d/ at once, to
maximize concurrency, as Debian uses init.d scripts also for the early
boot.  Also, would be nice to get dynamic resolution of $remote_fs, to
let it be equal to $local_fs if no networked file systems are listed
in /etc/fstab. :) Not sure how hard that would be.  Lets continue this
part of the discussion without CC-ing the BTS.

Happy hacking,
-- 
Petter Reinholdtsen




Reply sent to Petter Reinholdtsen <pere@debian.org>:
You have taken responsibility. (Thu, 10 Jun 2010 15:57:03 GMT) Full text and rfc822 format available.

Notification sent to Bartosz Pierzchala <bartosz.pierzchala@gmail.com>:
Bug acknowledged by developer. (Thu, 10 Jun 2010 15:57:03 GMT) Full text and rfc822 format available.

Message #72 received at 584102-close@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@debian.org>
To: 584102-close@bugs.debian.org
Subject: Bug#584102: fixed in sysvinit 2.88dsf-8
Date: Thu, 10 Jun 2010 15:52:47 +0000
Source: sysvinit
Source-Version: 2.88dsf-8

We believe that the bug you reported is fixed in the latest version of
sysvinit, which is due to be installed in the Debian FTP archive:

initscripts_2.88dsf-8_i386.deb
  to main/s/sysvinit/initscripts_2.88dsf-8_i386.deb
sysv-rc_2.88dsf-8_all.deb
  to main/s/sysvinit/sysv-rc_2.88dsf-8_all.deb
sysvinit-utils_2.88dsf-8_i386.deb
  to main/s/sysvinit/sysvinit-utils_2.88dsf-8_i386.deb
sysvinit_2.88dsf-8.diff.gz
  to main/s/sysvinit/sysvinit_2.88dsf-8.diff.gz
sysvinit_2.88dsf-8.dsc
  to main/s/sysvinit/sysvinit_2.88dsf-8.dsc
sysvinit_2.88dsf-8_i386.deb
  to main/s/sysvinit/sysvinit_2.88dsf-8_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 584102@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Petter Reinholdtsen <pere@debian.org> (supplier of updated sysvinit package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Thu, 10 Jun 2010 15:41:18 +0200
Source: sysvinit
Binary: sysvinit sysvinit-utils sysv-rc initscripts
Architecture: source i386 all
Version: 2.88dsf-8
Distribution: unstable
Urgency: low
Maintainer: Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>
Changed-By: Petter Reinholdtsen <pere@debian.org>
Description: 
 initscripts - scripts for initializing and shutting down the system
 sysv-rc    - System-V-like runlevel change mechanism
 sysvinit   - System-V-like init utilities
 sysvinit-utils - System-V-like utilities
Closes: 584102 584742
Changes: 
 sysvinit (2.88dsf-8) unstable; urgency=low
 .
   * New startpar patch 06_stdin_notty.patch to make sure startpar run
     programs also when stdin is a pipe, to get it working on OpenVZ
     (Closes: #584102)
   * New startpar patch 07_nocrash_missing_arg.patch to make sure
     missing argument (-a) do not cause startpar to segfault.
   * Change startpar patch 05_pri_kdm_gdm.patch to also give priority
     to udev to get kernel module loading started as early as possible
     during boot.  Based on idea from live-net-startpar.
   * Make init.d/bootlogs soft depend on gdm3 while we wait for gdm3 to
     provide $x-display-manager.
   * Make sure to create /dev/pts/ and /dev/shm/ in mountdevsub.sh
     before mounting them to allow udev to stop creating them at boot
     (Closes: #584742).  Thanks to Marco d'Itri for the patch.
   * Drop support for the now obsolete devfs file system in the init.d
     scripts bootmisc.sh, checkroot.sh, mountdevsubfs.sh, umountfs and
     umountnfs.sh.
   * Loosen up the migration check to dependency based boot sequencing,
     to only report removed but not purged packages if insserv detected
     problems with the init.d script dependencies.
   * Add Norwegian Bokmål (nb) debconf translation.
Checksums-Sha1: 
 46f09a9d93526a43bf9ab2dae5f85299f11fe4b0 1506 sysvinit_2.88dsf-8.dsc
 36e38341ed807d694b3fa765b9d5c0a0223459ab 162406 sysvinit_2.88dsf-8.diff.gz
 50061807ff7d8a6799ce4147ff36ae5eb5362fd1 114144 sysvinit_2.88dsf-8_i386.deb
 018432c8aafec8a3bed5b197bbae52c2e53cf250 116760 sysvinit-utils_2.88dsf-8_i386.deb
 0b09d86ddfc6b66bcbdd1dd0df975c22a847bee9 69620 initscripts_2.88dsf-8_i386.deb
 f84ffb700d35a3c7d3eaa6f9d7dc9bed51534477 60718 sysv-rc_2.88dsf-8_all.deb
Checksums-Sha256: 
 d8636b61cde85d9a5de595126719cab42f4bb23455d60cab5f0788adbf0c87be 1506 sysvinit_2.88dsf-8.dsc
 bccba1825e4908dafe29ded1cbbe02c2c16ccb7876cc2e3b102fe3077fa63b12 162406 sysvinit_2.88dsf-8.diff.gz
 f5ded899582ba6bd40b0eea86e9446512064dcb37cde0aeebe4788ad327d8cb2 114144 sysvinit_2.88dsf-8_i386.deb
 041924b9447e8e513ccf51b4dcd621cbb635290396ebf0ee6378ede8d5b72220 116760 sysvinit-utils_2.88dsf-8_i386.deb
 c8e9eb11d1b000b75e83d56417b135c39ec0e2050019a19699a69f432af058d5 69620 initscripts_2.88dsf-8_i386.deb
 cf8b1d441d233936834e9fb9d5bf1f5ca85263ffc38e1d860056758835363668 60718 sysv-rc_2.88dsf-8_all.deb
Files: 
 a19dbec524d578f96c660b644810be85 1506 admin required sysvinit_2.88dsf-8.dsc
 63e58626b9d490a3b98f02a30de1b181 162406 admin required sysvinit_2.88dsf-8.diff.gz
 48a4939cd138fac75e5254a194b53d9e 114144 admin required sysvinit_2.88dsf-8_i386.deb
 a0fe19787f752ee738106a082ad2ab5f 116760 admin required sysvinit-utils_2.88dsf-8_i386.deb
 ae9c64638a2ba4bfd83a9dd195c96d54 69620 admin required initscripts_2.88dsf-8_i386.deb
 716a8328073484816ca199f0996f48f7 60718 admin required sysv-rc_2.88dsf-8_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iD8DBQFMEOzD20zMSyow1ykRAgxGAJ0ad2G7RDBuTUINo4uQYAXqOAYVxACfcE/y
sFe1sc3S0g7bRiba5q8Emjg=
=kNci
-----END PGP SIGNATURE-----





Reply sent to Petter Reinholdtsen <pere@debian.org>:
You have taken responsibility. (Thu, 10 Jun 2010 15:57:04 GMT) Full text and rfc822 format available.

Notification sent to Gabor Laszlo <gabor.laszlo@ieee.org>:
Bug acknowledged by developer. (Thu, 10 Jun 2010 15:57:04 GMT) Full text and rfc822 format available.

Added tag(s) sid and squeeze. Request was from Gerfried Fuchs <rhonda@debian.at> to control@bugs.debian.org. (Mon, 12 Jul 2010 15:06:06 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 07 Feb 2011 07:33:13 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 10:52:33 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.